import { Body, Post, Route, Tags, Example } from 'tsoa';
import { ICrawl, ICrawlMonth } from '../models/crawl.js';
import {
    ICreateCrawlRequest,
    ICreateCrawlMonthRequest,
} from "../services/crawlService.js";
import { queueCrawl, queueCrawlMonth } from '../services/crawlService.js';

@Route("crawl")
export class CrawlController {
    /**
     * Creates a crawl job which will find the dates of past livestreams via the specified platform 
     */
    @Post()
    @Tags("Crawl")
    public async CreateCrawl(@Body() request: ICreateCrawlRequest): Promise<ICrawl> {
        const cr = await queueCrawl(request);
        return cr;
    }
}

@Route("crawlMonth")
export class CrawlMonthController {
    @Post()
    @Tags("Crawl")
    public async CreateCrawlMonth(@Body() request: ICreateCrawlMonthRequest): Promise<ICrawlMonth> {
        const cr = await queueCrawlMonth(request);
        return cr;
    }
}