import dotenv from "dotenv";
dotenv.config();

function checkEnvVariable(name: string) {
  if (!process.env[name]) {
    throw new Error(`${name} is missing from env`);
  }
}

const requiredEnvVariables = [
  "TASK_LIST",
  "REDIS_HOST",
  "REDIS_PORT",
  "PORT",
  "IPFS_CLUSTER_HTTP_API_MULTIADDR",
  "IPFS_CLUSTER_HTTP_API_USERNAME",
  "IPFS_CLUSTER_HTTP_API_PASSWORD",
  "TWITTER_ACCOUNTS",
  "STRAPI_API_KEY",
  "STRAPI_URL",
  "B2_ENDPOINT",
  "B2_REGION",
  "B2_KEY",
  "B2_SECRET",
  "TMPDIR",
];

requiredEnvVariables.forEach(checkEnvVariable);

export const REDIS_PORT = process.env.REDIS_PORT as string;
export const TASK_LIST = process.env.TASK_LIST as string;
export const REDIS_HOST = process.env.REDIS_HOST as string;
export const PORT = process.env.PORT as string;
export const IPFS_CLUSTER_HTTP_API_MULTIADDR = process.env.IPFS_CLUSTER_HTTP_API_MULTIADDR as string;
export const IPFS_CLUSTER_HTTP_API_USERNAME = process.env.IPFS_CLUSTER_HTTP_API_USERNAME as string;
export const IPFS_CLUSTER_HTTP_API_PASSWORD = process.env.IPFS_CLUSTER_HTTP_API_PASSWORD as string;
export const TWITTER_ACCOUNTS = process.env.TWITTER_ACCOUNTS as string;
export const STRAPI_API_KEY = process.env.STRAPI_API_KEY as string;
export const STRAPI_URL = process.env.STRAPI_URL as string;
export const B2_ENDPOINT = process.env.B2_ENDPOINT as string;
export const B2_REGION = process.env.B2_REGION as string;
export const B2_KEY = process.env.B2_KEY as string;
export const B2_SECRET = process.env.B2_SECRET as string;
export const TMPDIR = process.env.TMPDIR as string;
