import { strapiUrl } from './constants.js'
import { IVod } from './vods.js';
import { unmarshallToy, IToy } from './toys.js';


export interface ITag {
    id: number;
    name: string;
    count: number;
}


export interface IToyTag extends ITag {
    toy: IToy;
}


export function unmarshallTag(d: any): ITag | IToyTag {


    const tag: ITag = {
        id: d.id,
        name: d.attributes.name,
        count: 0 // count gets updated later
    };

    if (d.attributes.toy && d.attributes.toy.data) {
        const toy: IToy = unmarshallToy(d.attributes.toy.data);
        const toyTag: IToyTag = { ...tag, toy };
        return toyTag;
    }

    return tag;
}



// export async function getTags(): Promise<ITag[]> {
//     const tagVodRelations = await fetchPaginatedData('/api/tag-vod-relations', 100, { 'populate[0]': 'tag', 'populate[1]': 'vod' });

//     // Create a Map to store tag data, including counts and IDs
//     const tagDataMap = new Map<string, { id: number, count: number }>();

//     // Populate the tag data map with counts and IDs
//     tagVodRelations.forEach(tvr => {
//         const tagName = tvr.attributes.tag.data.attributes.name;
//         const tagId = tvr.attributes.tag.data.id;
        
//         if (!tagDataMap.has(tagName)) {
//             tagDataMap.set(tagName, { id: tagId, count: 1 });
//         } else {
//             const existingData = tagDataMap.get(tagName);
//             if (existingData) {
//                 tagDataMap.set(tagName, { id: existingData.id, count: existingData.count + 1 });
//             }
//         }
//     });

//     // Create an array of Tag objects with id, name, and count
//     const tags: ITag[] = Array.from(tagDataMap.keys()).map(tagName => {
//         const tagData = tagDataMap.get(tagName);
//         return {
//             id: tagData ? tagData.id : -1,
//             name: tagName,
//             count: tagData ? tagData.count : 0,
//         };
//     });


//     return tags;
// }
