


import { getVod } from '../vods.js';
import { ITaskOptions, IRunTaskFunction } from "../Task.js";
import { IJobData } from "../types.js";
import { pinCid } from "../ipfsCluster.js";


export const name = 'pinVideoSrcHash';

export const runTask: IRunTaskFunction = async ({ logger, env, job }: ITaskOptions) => {
    const jobData = job.data as IJobData;
    const vod = await getVod(jobData.id, env);
    if (!vod) throw new Error('pinVideoSrcHash received no vod, which is required.');
    const cid = await pinCid(env, logger, vod.attributes.videoSrcHash);
    return cid;
}

