
import { ITag } from './tags.js'


export interface IToys {
    data: IToy[];
    pagination: {
        page: number;
        pageSize: number;
        pageCount: number;
        total: number;
    }
}

export interface IToy {
    id: number;
    tags: ITag[];
    linkTag: ITag;
    make: string;
    model: string;
    aspectRatio: string;
    image2: string;
}


interface IToysListProps {
    toys: IToys;
    page: number;
    pageSize: number;
}


/** This endpoint doesn't exist at the moment, but definitely could in the future */
// export function getUrl(toy: IToy): string {
//     return `${siteUrl}/toy/${toy.name}`
// }

// export function getToysForVtuber(vtuberId: number, page: number = 1, pageSize: number = 25): Promise<IToys> {
//     const tvrs = await getTagVodRelationsForVtuber(vtuberId, page, pageNumber);
//     return {
//         data: tvrs.data.
//         pagination: tvrs.pagination
//     }
// }

export function unarshallLinkTag(d: any): ITag {

    return {
        id: d.id,
        name: d.attributes?.name,
        count: 0
    }
}

export function unmarshallToy(d: any): IToy {

    const toy = {
        id: d.id,
        // tags: d.attributes.tags.data.map(unmarshallTag),
        // linkTag: unmarshallTag(d.attributes.linkTag)
        tags: [],
        make: d.attributes.make,
        model: d.attributes.model,
        aspectRatio: d.attributes.aspectRatio,
        image2: d.attributes.image2,
        linkTag: unarshallLinkTag(d.attributes?.linkTag?.data),
    }
    return toy
}

