
import { IVod } from './vods.js'
import { strapiUrl } from './constants.js';
import { getSafeDate } from './dates.js';
import qs from 'qs';

export interface IVtuber {
    id: number;
    attributes: {
        slug: string;
        displayName: string;
        chaturbate?: string;
        twitter?: string;
        patreon?: string;
        twitch?: string;
        tiktok?: string;
        onlyfans?: string;
        youtube?: string;
        linktree?: string;
        carrd?: string;
        fansly?: string;
        pornhub?: string;
        discord?: string;
        reddit?: string;
        throne?: string;
        instagram?: string;
        facebook?: string;
        merch?: string;
        vods: IVod[];
        description1: string;
        description2?: string;
        image: string;
        imageBlur?: string;
        themeColor: string;
    }
}


// export function unmarshallVtuber(d: any): IVtuber {
//     if (!d) {
//         console.error('panick! unmarshallVTuber was called with undefined data')
//         console.trace()
//     }
//     return {
//         id: d.id,
//         slug: d.attributes?.slug,
//         displayName: d.attributes.displayName,
//         chaturbate: d.attributes?.chaturbate,
//         twitter: d.attributes?.twitter,
//         patreon: d.attributes?.patreon,
//         twitch: d.attributes?.twitch,
//         tiktok: d.attributes?.tiktok,
//         onlyfans: d.attributes?.onlyfans,
//         youtube: d.attributes?.youtube,
//         linktree: d.attributes?.linktree,
//         carrd: d.attributes?.carrd,
//         fansly: d.attributes?.fansly,
//         pornhub: d.attributes?.pornhub,
//         discord: d.attributes?.discord,
//         reddit: d.attributes?.reddit,
//         throne: d.attributes?.throne,
//         instagram: d.attributes?.instagram,
//         facebook: d.attributes?.facebook,
//         merch: d.attributes?.merch,
//         description1: d.attributes.description1,
//         description2: d.attributes?.description2,
//         image: d.attributes.image,
//         imageBlur: d.attributes?.imageBlur,
//         themeColor: d.attributes.themeColor,
//         vods: d.attributes.vods
//     }
// }

export async function getVtuberBySlug(slug: string): Promise<IVtuber> {
    const query = qs.stringify(
        {
            filters: {
                slug: {
                    $eq: slug
                }
            },
            // populate: {
            //     vods: {
            //         fields: ['id', 'videoSrcHash'],
            //         populate: ['vtuber']
            //     }
            // }
        }
    )

    return fetch(`${strapiUrl}/api/vtubers?${query}`)
        .then((res) => res.json())
        .then((d) => {
            return d.data[0]
        })
}

export async function getVtuberById(id: number): Promise<IVtuber> {
    return fetch(`${strapiUrl}/api/vtubers?filters[id][$eq]=${id}`)
        .then((res) => res.json())
        .then((data) => {
            return data.data[0]
        })
}

export async function getVtubers(): Promise<IVtuber[]> {
    return fetch(`${strapiUrl}/api/vtubers`)
        .then((res) => res.json())
        .then((data) => {
            return data.data
        })
}

